var C b;
varexo epsi_b epsi_c epsi_d;

parameters beta;
//New information revealed at the beginning of period 5
H1=5;


beta=0.99;

model;

C=beta*C(+1)+b+0.1*C(-1);

b=0.9*b(-1)+epsi_b+epsi_c+epsi_d;

end;

initval;
C=0;
b=0;
end;
steady;

iC  = varlist_indices('C',M_.endo_names);
ib  = varlist_indices('b',M_.endo_names);

shocks;
//on impact shock
var epsi_b;
periods 1;
values 1;

//shock expected for simulation period 8
var epsi_d;
periods 8;
values 10;
end;

simul(periods=100);

//Stores path variables would take if no new information would be revealed at the beginning of period 5
newsdet = oo_.endo_simul;
save newsdet newsdet;

histval;
b(0)  = newsdet(ib,H1); //Uses period 4 values
C(0)  = newsdet(iC,H1);
end;

//Remark: "simulation period" below always includes the period before new information was revealed.
shocks;
//new shock not expected previously which occurs in simulation period 10 (In quarter 6 of the new information era). 
var epsi_c;
periods 6;
values 5;



//Making sure that on impact shock remains zero in the period when new information is revealed (simulation period 5). 
var epsi_b;
periods 1;
values 0;



//First column: epsi_d shock happens as expected in simulation period 8 (Quarter 4 of the new information era), but not in any other period. 
var epsi_d;
periods 4 8;
values 10 0;

end;

simul(periods=100);
